void f1();
void f2();
void f3();

struct t1 {
	void(*ptr)();
};

struct t1 o1 = {
	.ptr = f1
};

static void call_t1() {
	o1.ptr();
}

void test1() {
	call_t1();
}

struct t2 {
	void(*ptr1)();
	void(*ptr2)();
};

struct t2 o2 = {
	.ptr1 = f2,
	.ptr2 = f3
};

static void call_t2() {
	o2.ptr1();
//	o2.ptr2();
}

void test2() {
	call_t2();
}

void test3(int x) {
	if (x == 0)
		o2.ptr1();
	else
		o2.ptr2();
}

struct t2 o4 = {
	.ptr2 = f1
};

void assign_t4() {
	o4.ptr1 = f2;
}

void test4() {
	o4.ptr1();
}

void test5() {
	o4.ptr2();
}

// Test load in first element
void g1();
void g2();

struct s1 {
	void(*ptr1)();
	void(*ptr2)();
};

struct s1 t6 = {
	.ptr1 = g1,
	.ptr2 = g2,
};

void test6() {
	t6.ptr1();
	t6.ptr2();
}

int main() {
	test1();
	test2();
	test3(1);
	test4();
	test5();
	test6();
	return 0;
}
